function TrSpn1PostL(FinalSpnDir,PostL,MvnK,SpnTrK,TrDir,DevDir,TrNS,DevNS,LabK,P,Gmm)
%Train SPN for One Posterior Label


%
fprintf('******************** Training SPN PostL: %d ***************************\n',PostL);

SpnModDir=[FinalSpnDir '/SpnMod' SpnTrK MvnK]; [x,x,x]=mkdir(SpnModDir); 
SpnModDirEM=[FinalSpnDir '/SpnModEM' SpnTrK MvnK]; [x,x,x]=mkdir(SpnModDirEM);

modelFile = [SpnModDir '/Spn0.mod'];
modelFileEM = [SpnModDirEM '/Spn0.mod'];

%Read samples
[Tr,Dev,NS]=ReDevTrAli1Lab(TrDir,DevDir,PostL,TrNS,DevNS,'rc',LabK);

%Normalize data
[XTrN,XDevN,Me,Std]=MvnTrDevData(Tr.Fe,Dev.Fe,MvnK,P);


%Main function for training
[Spn,modelFile,SpnMatDir]=SwitTrSpn1Lab(FinalSpnDir,MvnK,SpnTrK,XTrN,XDevN,PostL,P,Gmm);


%Save 
Review
SaMod2MatSpn(SpnMatDir,Spn,modelFile,PostL,Tr,Dev,NS,Me,Std);




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [Spn,modelFile,SpnMatDir]=SwitTrSpn1Lab(FinalSpnDir,MvnK,SpnTrK,XTrN,XDevN,PostL,P,Gmm)
%

%Furure: To code
SpnModDir=[FinalSpnDir '/SpnMod'  MvnK SpnTrK]; [x,x,x]=mkdir(SpnModDir); 
SpnMatDir=[FinalSpnDir '/SpnMat'  MvnK SpnTrK]; [x,x,x]=mkdir(SpnMatDir); 



switch SpnTrK(1:3)

    case 'Gmm'
        [Spn,modelFile]=GmmTr(SpnModDir,XTrN,XDevN,PostL,Gmm,P,0);
        
    case 'Spn'
        [Spn,modelFile]=Ju2RobSpnTr1Lab(SpnModDir,XTrN,XDevN,PostL,P.SpnBinDir,Gmm,P,0);        
end



[SpnEM,modelFileEM]=SpnEMTr1Lab(SpnModEMDir,modelFile,XTrN,XDevN,PostL,P.SpnBinDir,P);












